from ctypes import *
from path import path
from headers import TRDFileHdr
from hobeta import HobetaFile

def load(f):
    if getattr(f, 'read', None):
        data = f.read()
    elif getattr(f, 'bytes', None):
        data = f.bytes()
    else:
        f = path(f)
        data = f.bytes()

    size = len(data)
    if size % 256 or size < 16*256 or data[0x8e7] != chr(0x10):
        return None

    files = []
    for i in range(142):
        hdr = TRDFileHdr()
        offset = i*sizeof(TRDFileHdr)
        memmove(addressof(hdr), data[offset:offset+sizeof(TRDFileHdr)], sizeof(TRDFileHdr))

        if not hdr.name:
            break

        n_secs = hdr.n_secs if hdr.n_secs else 256
        length = 256 * n_secs
        start = 256 * (16 * hdr.trk + hdr.sec)
        files.append(HobetaFile(data[start:start+length], hdr))

    return files


